| EM datagrams on *.kmall format Reg.no. 410224 rev G

Data Fields
KMbinary_def Struct Reference

#SKM - Sensor attitude data block. Data given timestamped, not corrected. More...

`#include <EMdgmFormat.h>`

## Data Fields
uint8_t | dgmType [4]
uint16_t | numBytesDgm
uint16_t | dgmVersion
uint32_t | time_sec
uint32_t | time_nanosec
uint32_t | status
Position.
double | latitude_deg
double | longitude_deg
float | ellipsoidHeight_m
Attitude.
float | roll_deg
float | pitch_deg
float | heading_deg
float | heave_m
Rates.
float | rollRate
float | pitchRate
float | yawRate
Velocities.
float | velNorth
float | velEast
float | velDown
Errors in data. Sensor data quality, as standard deviations.
float | latitudeError_m
float | longitudeError_m
float | ellipsoidHeightError_m
float | rollError_deg
float | pitchError_deg
float | headingError_deg
float | heaveError_m
Acceleration.
float | northAcceleration
float | eastAcceleration
float | downAcceleration

## Detailed Description

#SKM - Sensor attitude data block. Data given timestamped, not corrected.

See Coordinate systems for definition of positive angles and axis.

Definition at line 295 of file EMdgmFormat.h.

## Field Documentation

## ◆ dgmType

uint8_t dgmType[4]

#KMB

Definition at line 297 of file EMdgmFormat.h.

## ◆ numBytesDgm

uint16_t numBytesDgm

Datagram length in bytes. The length field at the start (4 bytes) and end of the datagram (4 bytes) are included in the length count.

Definition at line 298 of file EMdgmFormat.h.

## ◆ dgmVersion

uint16_t dgmVersion

Datagram version.

Definition at line 299 of file EMdgmFormat.h.

## ◆ time_sec

uint32_t time_sec

UTC time from inside KM sensor data. Unit second. Epoch 1970-01-01 time. Nanosec part to be added for more exact time.
If time is unavailable from attitude sensor input, time of reception on serial port is added to this field.

Definition at line 300 of file EMdgmFormat.h.

## ◆ time_nanosec

uint32_t time_nanosec

Nano seconds remainder. Nanosec part to be added to time_sec for more exact time.
If time is unavailable from attitude sensor input, time of reception on serial port is added to this field.

Definition at line 302 of file EMdgmFormat.h.

## ◆ status

uint32_t status

Bit pattern for indicating validity of sensor data, and reduced performance. The status word consists of 32 single bit flags numbered from 0 to 31, where 0 is the least significant bit.
Bit number 0-7 indicate if from a sensor data is invalid. 0 = valid data, 1 = invalid data.
Bit number 16-> indicate if data from sensor has reduced performance. 0 = valid data, 1 = reduced performance.

Invalid data:

Bit number | Sensor data
--- | ---
0 | Horizontal position and velocity
1 | Roll and pitch
2 | Heading
3 | Heave and vertical velocity
4 | Acceleration
5 | Error fields
6 | Delayed heave

Reduced performance:

Bit number | Sensor data
--- | ---
16 | Horizontal position and velocity
17 | Roll and pitch
18 | Heading
19 | Heave and vertical velocity
20 | Acceleration
21 | Error fields
22 | Delayed heave

Definition at line 304 of file EMdgmFormat.h.

## ◆ latitude_deg

double latitude_deg

Position in decimal degrees.

Definition at line 339 of file EMdgmFormat.h.

## ◆ longitude_deg

double longitude_deg

Position in decimal degrees.

Definition at line 340 of file EMdgmFormat.h.

## ◆ ellipsoidHeight_m

float ellipsoidHeight_m

Height of sensor reference point above the ellipsoid. Positive above ellipsoid. ellipsoidHeight_m is not corrected for motion and installation offsets of the position sensor.

Definition at line 341 of file EMdgmFormat.h.

## ◆ roll_deg

float roll_deg

Roll. Unit degree.

Definition at line 345 of file EMdgmFormat.h.

## ◆ pitch_deg

float pitch_deg

Pitch. Unit degree.

Definition at line 346 of file EMdgmFormat.h.

## ◆ heading_deg

float heading_deg

Heading of vessel. Unit degree. Relative to the fixed coordinate system, i.e. true north.

Definition at line 347 of file EMdgmFormat.h.

## ◆ heave_m

float heave_m

Heave. Unit meter. Positive downwards.

Definition at line 348 of file EMdgmFormat.h.

## ◆ rollRate

float rollRate

Roll rate. Unit degree/s

Definition at line 353 of file EMdgmFormat.h.

## ◆ pitchRate

float pitchRate

Pitch rate. Unit degree/s

Definition at line 354 of file EMdgmFormat.h.

## ◆ yawRate

float yawRate

Yaw (heading) rate. Unit degree/s

Definition at line 355 of file EMdgmFormat.h.

## ◆ velNorth

float velNorth

Velocity North (X). Unit m/s

Definition at line 360 of file EMdgmFormat.h.

## ◆ velEast

float velEast

Velocity East (Y). Unit m/s

Definition at line 361 of file EMdgmFormat.h.

## ◆ velDown

float velDown

Velocity downwards (Z). Unit m/s

Definition at line 362 of file EMdgmFormat.h.

## ◆ latitudeError_m

float latitudeError_m

Latitude error. Unit meter.

Definition at line 367 of file EMdgmFormat.h.

## ◆ longitudeError_m

float longitudeError_m

Longitude error. Unit meter.

Definition at line 368 of file EMdgmFormat.h.

## ◆ ellipsoidHeightError_m

float ellipsoidHeightError_m

Ellipsoid height error. Unit meter.

Definition at line 369 of file EMdgmFormat.h.

## ◆ rollError_deg

float rollError_deg

Roll error. Unit degree.

Definition at line 370 of file EMdgmFormat.h.

## ◆ pitchError_deg

float pitchError_deg

Pitch error. Unit degree.

Definition at line 371 of file EMdgmFormat.h.

## ◆ headingError_deg

float headingError_deg

Heading error. Unit degree.

Definition at line 372 of file EMdgmFormat.h.

## ◆ heaveError_m

float heaveError_m

Heave error. Unit meter.

Definition at line 373 of file EMdgmFormat.h.

## ◆ northAcceleration

float northAcceleration

Unit m/s^2.

Definition at line 378 of file EMdgmFormat.h.

## ◆ eastAcceleration

float eastAcceleration

Unit m/s^2.

Definition at line 379 of file EMdgmFormat.h.

## ◆ downAcceleration

float downAcceleration

Unit m/s^2.

Definition at line 380 of file EMdgmFormat.h.

The documentation for this struct was generated from the following file:

- EMdgmFormat.h